# Interface ThreadGroupReference

All Superinterfaces:
  `Mirror`, `ObjectReference`, `Value`

public interface ThreadGroupReference extends ObjectReference
A thread group object from the target VM. A ThreadGroupReference is an `ObjectReference` with additional access to threadgroup-specific information from the target VM.

Since:
  1.3

## Field Summary

### Fields declared in interface com.sun.jdi.ObjectReference

`INVOKE_NONVIRTUAL, INVOKE_SINGLE_THREADED`

## Method Summary

Modifier and Type
Method
Description
`String`
`name()`
Returns the name of this thread group.
`ThreadGroupReference`
`parent()`
Returns the parent of this thread group.
`void`
`resume()`
Resumes all threads in this thread group.
`void`
`suspend()`
Suspends all threads in this thread group.
`List<ThreadGroupReference>`
`threadGroups()`
Returns a List containing a `ThreadGroupReference` for each subgroup.
`List<ThreadReference>`
`threads()`
Returns a List containing a `ThreadReference` for each live platform thread in this thread group.

### Methods declared in interface com.sun.jdi.Mirror

`toString, virtualMachine`

### Methods declared in interface com.sun.jdi.ObjectReference

`disableCollection, enableCollection, entryCount, equals, getValue, getValues, hashCode, invokeMethod, isCollected, owningThread, referenceType, referringObjects, setValue, uniqueID, waitingThreads`

### Methods declared in interface com.sun.jdi.Value

`type`

## Method Details

### name

String name()
Returns the name of this thread group.

Returns:
  the string containing the thread group name.

### parent

ThreadGroupReference parent()
Returns the parent of this thread group.

Returns:
  a `ThreadGroupReference` mirroring the parent of this thread group in the target VM, or null if this is a top-level thread group.

### suspend

void suspend()
Suspends all threads in this thread group. Each thread in this group and in all of its subgroups will be suspended as described in `ThreadReference.suspend()`. This is not guaranteed to be an atomic operation; if the target VM is not interrupted at the time this method is called, it is possible that new threads will be created between the time that threads are enumerated and all of them have been suspended.

Throws:
  `VMCannotBeModifiedException` - if the VirtualMachine is read-only - see `VirtualMachine.canBeModified()`.

### resume

void resume()
Resumes all threads in this thread group. Each thread in this group and in all of its subgroups will be resumed as described in `ThreadReference.resume()`.

Throws:
  `VMCannotBeModifiedException` - if the VirtualMachine is read-only - see `VirtualMachine.canBeModified()`.

### threads

List<ThreadReference> threads()
Returns a List containing a `ThreadReference` for each live platform thread in this thread group. Virtual threads are not included. Only the live platform threads in this immediate thread group (and not its subgroups) are returned. A thread is alive if it has been started and has not terminated.

Returns:
  a List of `ThreadReference` objects mirroring the live platform threads from this thread group in the target VM.

### threadGroups

List<ThreadGroupReference> threadGroups()
Returns a List containing a `ThreadGroupReference` for each subgroup. Only the thread groups in this immediate thread group (and not its subgroups) are returned.

Returns:
  a List of `ThreadGroupReference` objects mirroring the thread groups from this thread group in the target VM.